/**
 * 
 */
$(document).ready(function() {
  $.ajaxSetup({ cache: false });
 });

function select_file(){  
        document.getElementById("up_file").click();  
    var name = document.getElementById("up_file").value;  
}  
var timer;

function showDialog(status, error) {
  var q = '';

  /* Restore deny button, which may have been hidden by previous execution, or
     hide it if useless */
  if (status == 9) {
    $('.deny').show();
  }
  else if (status == 1 || status == 2 || status == 3 || status == 4) {
    $('.deny').hide();
  }

  /* Handle messages */
  if (status == 1) {
    q = 'Error: ' + error;
  }
  /* (status == 2) is implicit in message */
  if (status == 3) {
    q = 'Reboot needed';
  }
  else if (status == 4) {
    q = 'Restart needed';
  }
  else if (status == 9) {
    q = 'Confirm?';
  }

  $('.interactMsg').html(q);
  $('.interact').show();
}

function upgConfirm() {
  $('.interact').hide();
  timer = setInterval(getProgress, 1000);

  $.get("/Upgrade.cgi?confirm=1", function(){});
}

function upgDeny() {
  $('.interact').hide();
  $('.msg').empty();
  $('.uploadBar').width('0%');
  $('.uploadPercent').html('0%');
  $('.upgradeBar').width('0%');
  $('.upgradePercent').html('0%');

  $.get("/Upgrade.cgi?confirm=0", function(){});
}

function getProgress(progress) {
  var upgradeBar = $('.upgradeBar');
  var upgradePercent = $('.upgradePercent');
  var msg = $('.msg');
  $.getJSON( "/Upgrade.cgi", function( json ) {
    console.log("JSON Data error: " + json.error + " status: " + json.status);
    var percentVal2 = json.progress + '%';
    upgradeBar.width(percentVal2)
    upgradePercent.html(percentVal2);
    msg.html(json.msg);

    if (json.status != 5 && json.status != 10) {
      clearInterval(timer);
    }

    /* Show interact panel only when a user interaction is required */
    $('.interact').hide();
    if (json.status == 1 || json.status == 2 || json.status == 3 ||
        json.status == 4 || json.status == 9) {
      showDialog(json.status, json.error);
    }
  });
}

(function() {
  $('form').ajaxForm({
    beforeSend: function() {
      var percentVal = '0%';
      $('.uploadBar').width(percentVal);
      $('.uploadPercent').html(percentVal);
      $('.upgradeBar').width(percentVal);
      $('.upgradePercent').html(percentVal);
    },
    uploadProgress: function(event, position, total, percentComplete) {
      var percentVal = percentComplete + '%';
      $('.upgradeBar').width(percentVal);
      $('.upgradePercent').html(percentVal);
      $('.msg').html('Upgrade in progress');
    },
    success: function() {
      var percentVal = '100%';
      $('.upgradeBar').width(percentVal);
      $('.upgradePercent').html(percentVal);
	  $('.msg').html('Upload success');
    },
    complete: function(xhr) {
      console.log(xhr.responseText);
      var obj = jQuery.parseJSON( xhr.responseText );
      if (obj.error == 0)
        timer = setInterval(getProgress, 1000);
    }
});

})();